Index: funcs/func_odbc.c
===================================================================
--- funcs/func_odbc.c
+++ funcs/func_odbc.c
@@ -396,7 +396,7 @@ static int acf_odbc_read(struct ast_chan
 	struct ast_str *sql = ast_str_thread_get(&sql_buf, 16);
 	const char *status = "FAILURE";
 
-	if (!sql) {
+	if (!sql || !colnames) {
 		pbx_builtin_setvar_helper(chan, "ODBCSTATUS", status);
 		return -1;
 	}
@@ -539,6 +539,20 @@ static int acf_odbc_read(struct ast_chan
 			struct ast_str *coldata = ast_str_thread_get(&coldata_buf, 16);
 			char *ptrcoldata;
 
+			if (!coldata) {
+				ast_free(resultset);
+				SQLCloseCursor(stmt);
+				SQLFreeHandle(SQL_HANDLE_STMT, stmt);
+				ast_odbc_release_obj(obj);
+				obj = NULL;
+				pbx_builtin_setvar_helper(chan, "ODBCSTATUS", "MEMERROR");
+				if (chan)
+					ast_autoservice_stop(chan);
+				if (bogus_chan)
+					ast_channel_free(chan);
+				return -1;
+			}
+
 			if (y == 0) {
 				char colname[256];
 				SQLULEN maxcol;
